import * as React from 'react';
import * as common from 'schema-based-json-editor';
/**
 * @public
 */
export declare type Props = common.Props<common.StringSchema, string>;
/**
 * @public
 */
export declare type State = Partial<{
    value: string;
    errorMessage: string;
    collapsed: boolean;
    willRender: boolean;
}>;
export declare class StringEditor extends React.Component<Props, State> {
    private value?;
    private errorMessage;
    private collapsed;
    private willRender;
    private monacoEditorRef;
    private monacoCodeEditor?;
    constructor(props: Props);
    componentDidMount(): void;
    shouldComponentUpdate(nextProps: Props, nextState: State): boolean;
    componentWillUnmount(): void;
    render(): JSX.Element;
    private onChange;
    private get isReadOnly();
    private get hasDeleteButtonFunction();
    private get useTextArea();
    private get useInput();
    private get useSelect();
    private get useSelect2Component();
    private get useSelectComponent();
    private get useRadioBoxComponent();
    private get canPreviewImage();
    private get canPreviewMarkdown();
    private get canPreviewCode();
    private get canPreview();
    private get getImageUrl();
    private get getMarkdown();
    private get getCode();
    private get willPreviewImage();
    private get willPreviewMarkdown();
    private get willPreviewCode();
    private get titleToShow();
    private get options();
    private get canUpload();
    private get className();
    private updateSelection;
    private fileGot;
    private validate;
    private toggleOptional;
    private collapseOrExpand;
}
